//  J2PrinterWebStartTest.java
//  A simple Web Start application using J2PrinterWorks.

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import javax.swing.*;
import com.wildcrest.j2printerworks.*; 

public class J2PrinterWebStartTest {

    static JTextPane pane;
    static J2PrinterWebStart printer;
    static JFrame frame;

    static public void main(String args[]) { 
        pane = new JTextPane(); 
        pane.setContentType("text/html");
        pane.setText("<html>Here are two lines of <b>HTML text</b>"
					 + "<br>that <u>will be printed</u></html>"); 
		
        printer = new J2PrinterWebStart();
        printer.setPageable(new J2TextPrinter(pane));
        printer.setPrintPreviewCloseOnPrint(J2Printer.BEFORE); // works best in browsers
		
	  frame = new JFrame("J2PrinterWebStartTest application");
        frame.getContentPane().setLayout(new BorderLayout());
		
        frame.getContentPane().add(pane,"Center"); 
		
        JPanel buttons = new JPanel(); buttons.setBackground(Color.white);
        
        JButton print = new JButton("Print");
        JButton preview = new JButton("Print preview");
        JButton setup = new JButton("Page Setup");
        
        buttons.add(print); 
        buttons.add(preview); 
        buttons.add(setup);
        
        frame.getContentPane().add(buttons,"South");
		
        frame.pack();
        frame.setSize(400,300); 
        frame.setVisible(true); 
		
        print.addActionListener(new ActionListener() { 
								public void actionPerformed(ActionEvent e) { printer.print();  }}); 
        preview.addActionListener(new ActionListener() { 
								  public void actionPerformed(ActionEvent e) { printer.showPrintPreviewDialog(frame); }}); 
        setup.addActionListener(new ActionListener() { 
								public void actionPerformed(ActionEvent e) { printer.showPageSetupDialog(); }}); 
		
        frame.addWindowListener( new java.awt.event.WindowAdapter() {
								public void windowClosing(java.awt.event.WindowEvent e)
								{ System.out.println("exit"); System.exit(0); }  }  );  
    }
	
}
